{-# LANGUAGE GADTs #-}
{-# LANGUAGE FunctionalDependencies #-}
module Functions where

import Types
import Sources

data Function a b where
  IsImageFilename :: Function FilePath Bool
  ConvertedImageFilename :: Function FilePath FilePath

deriving instance Show (Function a b)

class (SourceState a, Show f) => IsFIO f a b | f -> a b where
  runFIO :: f -> a -> IO b

data ListDirectory = ListDirectory deriving (Show)
instance IsFIO ListDirectory FilePath [FilePath] where
  runFIO ListDirectory _path = undefined

data OpenImage = OpenImage deriving (Show)
instance IsFIO OpenImage FilePath Image where
  runFIO OpenImage _path = undefined

data ConvertImage = ConvertImage deriving (Show)
instance IsFIO ConvertImage Image Image where
  runFIO ConvertImage _image = undefined

data SaveFile = SaveFile deriving (Show)
instance IsFIO SaveFile (String, FilePath) () where
  runFIO SaveFile _source = undefined

data RunPandoc = RunPandoc deriving (Show)
instance IsFIO RunPandoc String String where
  runFIO RunPandoc _source = undefined
